//*****************************************************************************
//  $RCSfile: config.h,v $
//-----------------------------------------------------------------------------
//  Copyright (c) 2003 Atmel.
//-----------------------------------------------------------------------------
//  J:		$Name: avr-can11-lib-mcu-0_0_3 $
//  :		$Revision: 1.2 $
//  FILE_CVSID:	$Id: config.h,v 1.2 2004/03/29 11:09:59 jberthy Exp $
//-----------------------------------------------------------------------------
//  ړI:
//  `Ԑݒ̧فB޲̑IB
//*****************************************************************************
#ifndef _CONFIG_H_
#define _CONFIG_H_

//---------------- ۾` -------------------------------------------------
// ! '`'Ͳݸٰ ̧ق̑OɒuȂ΂Ȃ܂B

// S
#define AVR
#define AT90CAN128	1
#define AT90CAN64	2
#define AT90CAN32	3

// (ްĂ܂͉p̊Jnp)ʰ޳
  // DVK90CAN1łINT=INT0܂PD.0 - ٱߕtLow
	#define PIN_HWCB		PIND_Bit0
	#define PORT_HWCB		PORTD_Bit0
	#define LEVEL_HWCB		0			// "0"܂"1"Ŋ
	#define PULLUP_HWCB		1			// ٱ:"ON"="1","OFF"="0"
/*  // DVK90CAN1̒=PE.2 - ٱߕtLow
	#define PIN_HWCB		PINE_Bit2
	#define PORT_HWCB		PORTE_Bit2
	#define LEVEL_HWCB		0			// "0"܂"1"Ŋ
	#define PULLUP_HWCB		1			// ٱ:"ON"="1","OFF"="0" */

// p
#define USE_DEVICE		AT90CAN128
#define USE_UART1
#define FOSC			8000

// `p؂ւ
#ifndef USE_DEVICE
#		error ŏ"config.h"̧قUSE_DEVICE AT90CAN128܂AT90CAN64܂AT90CAN32`Ȃ΂Ȃ܂B
#	elif USE_DEVICE == AT90CAN128
#		define MANUF_ID			0x1E		// (ATMEL)
#		define FAMILY_CODE		0x97		// 128K޲ ׯ 
#		define PRODUCT_NAME		0x81		// AT90CANn
#		define PRODUCT_REV		0x00		// 0
#		define FLASH_SIZE		0x1FFFF		// ޲Ăłׯ ؗ
#		define FLASH_PAGE_SIZE	0x100		// ޲Ăłׯ ߰ޗe
#		define BOOT_SIZE		0x2000		// ޲Ăłްė̈e
#		define EEPROM_SIZE		0x1000		// ޲ĂłEEPROM
#	elif USE_DEVICE == AT90CAN64
#		define MANUF_ID			0x1E		// (ATMEL)
#		define FAMILY_CODE		0x96		// 64K޲ ׯ 
#		define PRODUCT_NAME		0x81		// AT90CANn
#		define PRODUCT_REV		0x00		// 0
#		define FLASH_SIZE		0x0FFFF		// ޲Ăłׯ ؗ
#		define FLASH_PAGE_SIZE	0x100		// ޲Ăłׯ ߰ޗe
#		define BOOT_SIZE		0x2000		// ޲Ăłްė̈e
#		define EEPROM_SIZE		0x0800		// ޲ĂłEEPROM
#	elif USE_DEVICE == AT90CAN32
#		define MANUF_ID			0x1E		// (ATMEL)
#		define FAMILY_CODE		0x95		// 32K޲ ׯ 
#		define PRODUCT_NAME		0x81		// AT90CANn
#		define PRODUCT_REV		0x00		// 0
#		define FLASH_SIZE		0x07FFF		// ޲Ăłׯ ؗ
#		define FLASH_PAGE_SIZE	0x100		// ޲Ăłׯ ߰ޗe
#		define BOOT_SIZE		0x2000		// ޲Ăłްė̈e
#		define EEPROM_SIZE		0x0400		// ޲ĂłEEPROM
#	else
#		error "config.h"̧قUSE_DEVICE`(肭)QƂ܂B
#endif

#ifndef USE_UART1
#		ifndef USE_UART2
#			error "config.h"̧قUSE_UART1USE_UART2̂ǂ炩`Ȃ΂Ȃ܂B
#		endif
#endif

// ߰ݸ ݒ`
#ifdef USE_UART1
#	define PIN_UART_RX		PINE_Bit0	// UART0p
#	define PORT_UART_TX		PORTE_Bit1	// UART0p
#endif
#ifdef USE_UART2
#	define PIN_UART_RX		PIND_Bit2	// UART1p
#	define PORT_UART_TX		PORTD_Bit3	// UART1p
#endif

#define PIN_CAN_RX			PIND_Bit6
#define PORT_CAN_TX			PORTD_Bit5

//---------------- ݸٰ ̧ -----------------------------------------------
#include "lib_mcu/compiler.h"
#include "lib_mcu/mcu.h"
#include "lib_mcu/mcu_drv.h"

//---------------- ޯޒ` ------------------------------------------------
// SĂ̒`͌JOɎ苎Ȃ΂Ȃ܂B
//#define DEBUG_BYPASSAUTOBAUD		// CAN=100kbps & CKIO=8MHz
//#define DEBUG_ISP_RD_COMMAND
//#define DEBUG_FLASHWR				// ۸тp̈Ɋ蓖Ăꂽꍇ

//------------- WIׯ ؒ` -----------------------------------------
#define Enable_flash()
#define Disable_flash()

//------------- WIEEPROM` --------------------------------------------
#define Enable_eeprom()
#define Disable_eeprom()

//------------- CAN` -------------------------------------------------------

//-------------- UARTײ،`Ԑݒ -------------------------------------------
#define UART_AUTOBAUD_EXTERNAL_DETECTION
#define UART_MINIMUM
#define BDR_GENERATOR	BRG_TIMER1
#define BAUDRATE		AUTOBAUD
//#define BAUDRATE		19200
#define test_hit()		uart_test_hit()
#define _getkey()		uart_getchar()
#define putchar			uart_putchar

//--------------- v敔`Ԑݒ ----------------------------------------------
#define SCHEDULER_TYPE			SCHEDULER_FREE	// SCHEDULER_(TIMED|TASK|FREE|CUSTOM)
#define Scheduler_task_1_init	boot_process
#define Scheduler_task_1		protocol_task
#define scheduler				main

#define ENTRY_POINT_USER_PRG	0

//-------------- ް۰ތ`Ԑݒ ---------------------------------------------
// UARTK
#define PROTOCOL_DATA					64
#define GLOBAL_BUFFER_SIZE				PROTOCOL_DATA+4
#define NB_BYTE_MAX_FOR_DISPLAY_COMMAND	64
#define HEX_SIZE_DISP_PAGE				16

//#undef USE_RCS_HEX_PROTOCOL
#define USE_RCS_HEX_PROTOCOL
#define USE_RCS_CAN_PROTOCOL

//----------- ް۰ގʒ` ------------------------------------------------
// ް ؒ`
#define BOOT_VERSION	0x01	//0x10	// @00	// Ver 01: JT-18.10.05
#define BOOT_ID1		0xD1	// 2	// @01
#define BOOT_ID2		0xD2	// 0	// @02

#define SECUR32			0xF0F0F0F0
#define SECUR16			0xF0F0
#define SECUR8			0xF0

#define NO_SECURITY		0xFF
#define RD_WR_SECURITY	0xFC
#define BSB_DEFAULT		0xFF
#define SSB_DEFAULT		0xFF
#define EB_DEFAULT		0xFF
#define NNB_DEFAULT		0xFF
#define CRIS_DEFAULT	0xFF
#define BTC1_DEFAULT	0xFF
#define BTC2_DEFAULT	0xFF
#define BTC3_DEFAULT	0xFF

#define SSB_RD_PROTECTION	0xFC
#define SSB_WR_PROTECTION	0xFE

#define BSB		boot_conf[0]
#define SSB		boot_conf[5]
#define EB		boot_conf[6]
#define BTC1	boot_conf[0x1C]
#define BTC2	boot_conf[0x1D]
#define BTC3	boot_conf[0x1E]
#define NNB		boot_conf[0x1F]
#define CRIS	boot_conf[0x20]

//-------- ؒ` ------------------------------------------------------------
#define MEM_USER		0
#define MEM_CODE		0
#define MEM_FLASH		0
#define MEM_EEPROM		1
#define MEM_CUSTOM		2
#define MEM_BOOT		3	// ް۰ޏ
#define MEM_XAF			4	// ް۰ތ`Ԑݒ
#define MEM_HW			5
#define MEM_SIGNATURE	6
#define MEM_MULTICAST	128
#define MEM_DEFAULT		MEM_FLASH

#define PAGE_DEFAULT	0x00

#define ADDR_CONF_MAX	0x21

#ifndef __IAR_SYSTEMS_ASM__
	extern Uchar code boot_conf[];
#endif

#ifdef _INTEL_HEX_C_
#	include "lib_mcu/uart/uart_lib.h"
#endif

#endif  // CONFIG_H
