/*C**************************************************************************
* $RCSfile: boot_process.c,v $
*----------------------------------------------------------------------------
* Copyright (c) 2003 Atmel.
*----------------------------------------------------------------------------
* J:			$Name: can11-bl-uart-can-0_0_8 $
* :			$Revision: 1.5 $
* FILE_CVSID:	$Id: boot_process.c,v 1.5 2003/09/04 15:55:46 jberthy Exp $
*----------------------------------------------------------------------------
* ړI:
* ̧قްďLq܂݂܂B
* ̊֐ؾČAŏɌĂяoȂ΂Ȃ܂B
*****************************************************************************/
/*_____ ݸٰ ̧ _______________________________________________________*/

#include "config.h"
#include "lib_isp/can_isp/can_protocol.h"
#include "lib_isp/intel_hex/intel_hex.h"
#include "lib_mcu/uart/uart_lib.h"

/*_____ S _______________________________________________________________*/
Uchar protocol_select;

/*_____ p@\錾 _______________________________________________________*/
#define _PROTOCOL_UART	0
#define _PROTOCOL_CAN	1

/*_____ Ǐ _______________________________________________________________*/

/*F**************************************************************************
* O: boot_process
*----------------------------------------------------------------------------
* Ұ:
* return:	Ȃ
*----------------------------------------------------------------------------
* ړI:
* ̊֐ް۰ނ܂͉p̎s܂B
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* : ̊֐ؾČ̍ŏ̊֐ĂяołȂ΂Ȃ܂B
*----------------------------------------------------------------------------
* Kv:
*****************************************************************************/
void boot_process (void)
{
  bit hwcb = FALSE;
  register Uchar status = TRUE;

// ʰ޳͌`Ԑݒ
  // : ؾČ"͌`"߰
  if (PULLUP_HWCB==1) PORT_HWCB=1;
  hwcb = PIN_HWCB;
  if (LEVEL_HWCB==0) hwcb = (~hwcb) & 0x01;

// pJnAȂް۰ފJn
  if (((BSB!=BSB_DEFAULT)&&(hwcb==0))||((BSB==BSB_DEFAULT)&&(hwcb ==1))) asm("JMP 0");

// CAN܂UART̊҂
  PORT_UART_TX=1;	// UART_Txٱߋ
  PORT_CAN_TX=1;	// CAN_Txٱߋ
  do{
	if (PIN_UART_RX ==0)
	{
	  uart_init();
	  putchar('U');
	  status = FALSE;
	  protocol_select = _PROTOCOL_UART;
	}else if(PIN_CAN_RX == 0)
	{
	  can_init_from_reset();
	  status = FALSE;
	  protocol_select = _PROTOCOL_CAN;
	}
  }while(status);

  if (protocol_select == _PROTOCOL_UART)
  {
	intel_hex_init();
  }
  else
  {
	can_protocol_task_init();
  }
}

/*F**************************************************************************
* O: protocol_task
*----------------------------------------------------------------------------
* Ұ:
* ߂l: Ȃ
*----------------------------------------------------------------------------
* ړI:
* ̊֐͑IKǗ܂B
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* :
*----------------------------------------------------------------------------
* Kv:
*****************************************************************************/
void protocol_task (void)
{
  if (protocol_select == _PROTOCOL_UART)
  {
	intel_hex();
  }
  else
  {
	can_protocol_task();
  }
}
