/*H**************************************************************************
* $RCSfile: uart_lib.h,v $
*----------------------------------------------------------------------------
* Copyright (c) 2003 Atmel.
*----------------------------------------------------------------------------
* J:			$Name: can11-bl-uart-can-0_0_8 $
* :			$Revision: 1.14 $
* FILE_CVSID:	$Id: uart_lib.h,v 1.14 2003/08/29 12:45:13 jberthy Exp $
*----------------------------------------------------------------------------
* ړI:
* UARTײ ͯ ̧
*****************************************************************************/

#ifndef _UART_LIB_H_
#define _UART_LIB_H_

/*_____ `Ԑݒ ___________________________________________________________*/

/*_____ ` _______________________________________________________________*/
#define XON				0x11
#define XOFF			0x13

// BDR_GENERATOR`:
#ifndef BDR_GENERATOR
#error config.hBDR_GENERATOR`Ȃ΂Ȃ܂B
#define BDR_GENERATOR	999
#endif

#define BRG_INTERNAL	0
#define BRG_TIMER1		1
#define BRG_TIMER2		2

#ifndef UART_CONFIG
#define UART_CONFIG		MSK_UART_8BIT
#endif

#ifndef BAUDRATE
#error config.hBAUDRATE`Ȃ΂Ȃ܂B
#define BAUDRATE		999
#endif

#define AUTOBAUD		0

#if BAUDRATE == AUTOBAUD
#define Uart_set_baudrate(bdr)	autobaud()
#include "modules/autobaud/autobaud.h"
#else
#include "uart_bdr.h"
#endif

/*_____ 錾 _______________________________________________________________*/
#ifdef UART_DEFAULT_INPUT
#define uart_getchar			_getkey
#define uart_test_hit			test_hit
#endif

#ifdef UART_DEFAULT_OUTPUT
#define uart_putchar			putchar
#endif

/*_____ ϸ ________________________________________________________________*/

/*_____ ^ _______________________________________________________________*/
// CUSTOM_IOxpW֐
// o
bit     uart_init           (void);
char    uart_putchar        (char uc_wr_byte);
#ifndef UART_MINIMUM
void    uart_gotoxy         (Byte x, Byte y);
void    uart_clrscr         (void);
bit     uart_splash         (void);
// ̑
void    uart_puts           (char _GenericType_ * p);
extern char _ConstType_ txt_logo_atmel[];
#endif
// 
bit     uart_test_hit       (void);
char    uart_getchar        (void);
extern volatile bit         uart_hit;

#endif /* _UART_LIB_H_ */
